Skip to content

Commit

Permalink
Merge branch 'develop-olympus' into develop
Browse files Browse the repository at this point in the history
* develop-olympus:
  [ticket/11509] Exit with the expected (non-zero) exit status on failure.
  [ticket/11509] Output which commit is being inspected.
  [ticket/11509] Three dots means sym. difference, but we only want new commits.

Conflicts:
	.travis.yml
  • Loading branch information
nickvergessen committed Mar 1, 2014
2 parents e9ed9cd + 9f4908f commit d636cb0
Show file tree
Hide file tree
Showing 2 changed files with 26 additions and 5 deletions.
2 changes: 1 addition & 1 deletion .travis.yml
Original file line number Diff line number Diff line change
Expand Up @@ -33,7 +33,7 @@ script:
- sh -c "if [ '$TRAVIS_PHP_VERSION' = '5.5' -a '$DB' = 'mysql' ]; then ../phpBB/vendor/bin/phing sniff; fi"
- cd ..
- phpBB/vendor/bin/phpunit --configuration travis/phpunit-$DB-travis.xml
- sh -c "if [ '$TRAVIS_PHP_VERSION' = '5.5' -a '$DB' = 'mysql' -a '$TRAVIS_PULL_REQUEST' != 'false' ]; then git-tools/commit-msg-hook-range.sh origin/$TRAVIS_BRANCH...FETCH_HEAD; fi"
- sh -c "if [ '$TRAVIS_PHP_VERSION' = '5.5' -a '$DB' = 'mysql' -a '$TRAVIS_PULL_REQUEST' != 'false' ]; then git-tools/commit-msg-hook-range.sh origin/$TRAVIS_BRANCH..FETCH_HEAD; fi"

matrix:
allow_failures:
Expand Down
29 changes: 25 additions & 4 deletions git-tools/commit-msg-hook-range.sh
Original file line number Diff line number Diff line change
Expand Up @@ -5,26 +5,47 @@
#
# Calls the git commit-msg hook on all non-merge commits in a given commit range.
#
set -e

if [ "$#" -ne 1 ];
then
echo "Expected one argument (commit range, e.g. eef1b586...1666476b)."
echo "Expected one argument (commit range, e.g. phpbb/develop..ticket/12345)."
exit
fi

DIR=$(dirname "$0")
COMMIT_MSG_HOOK_PATH="$DIR/hooks/commit-msg"

COMMIT_RANGE="$1"
COMMIT_MSG_HOOK_PATH="$DIR/hooks/commit-msg"
COMMIT_MSG_HOOK_FATAL=$(git config --bool phpbb.hooks.commit-msg.fatal 2> /dev/null)
git config phpbb.hooks.commit-msg.fatal true

EXIT_STATUS=0
for COMMIT_HASH in $(git rev-list --no-merges "$COMMIT_RANGE")
do
echo "Inspecting commit message of commit $COMMIT_HASH"

# The git commit-msg hook takes a path to a file containing a commit
# message. So we have to extract the commit message into a file first,
# which then also needs to be deleted after our work is done.
COMMIT_MESSAGE_PATH="$DIR/commit_msg.$COMMIT_HASH"
git log -n 1 --pretty=format:%B "$COMMIT_HASH" > "$COMMIT_MESSAGE_PATH"

# Invoke hook on commit message file.
"$COMMIT_MSG_HOOK_PATH" "$COMMIT_MESSAGE_PATH"

# If any commit message hook complains with a non-zero exit status, we
# will send a non-zero exit status upstream.
if [ $? -ne 0 ]
then
EXIT_STATUS=1
fi

rm "$COMMIT_MESSAGE_PATH"
done

# Restore phpbb.hooks.commit-msg.fatal config
if [ -n "$COMMIT_MSG_HOOK_FATAL" ]
then
git config phpbb.hooks.commit-msg.fatal "$COMMIT_MSG_HOOK_FATAL"
fi

exit $EXIT_STATUS

0 comments on commit d636cb0

Please sign in to comment.